/* Program pro jednoduche odzkouseni ovladani motoru s radicem L293D 
 * zadavani volby chodu motoru, smeru otaceni a rychlosti je z pocitace PC 
 * terminalem pro seriovou komunikaci,prevodnikem USB/COM-TTL CH340 
  vagnervlastimil@seznam.cz
  */
#define potvrd 12   //PIN 12 DPS Arduino UNO potvrzeni dat PIN 12 RCLK 74HC595 
#define clk 4       //clk PIN 4 DPS Arduino UNO takt pro posun bitu PIN 11 74HC595 
#define data 8      //PIN 8 DPS Arduino UNO seriovy vstup dat do 74HC595 PIN 14 
#define prvnimotor 11     //vystupni pin 11 DIGITALWRITE DPS ENABLE VYSTUPU1, INPUT1 IO1
#define druhymotor 3      //vystupni pin 3 DIGITALWRITE DPS ENABLE VYSTUPU2, INPUT2  IO1  
#define tretimotor 6      //vystupni pin 6 DIGITALWRITE DPS ENABLE VYSTUPU1, INPUT1 IO2
#define ctvrtymotor 5      //vystupni pin 5 DIGITALWRITE DPS ENABLE VYSTUPU2, INPUT2 IO2
#define povolit 7         // vstup 13 74HC595 ovlada vstup OE
int cti;            //definovani promennych 
int hodnota;        //definovani promennych
int cislo1, cislo2, cislo3, cislo4; 
//promenne cislo1=hodnota motor1,cislo2=hodnota motor2, cislo3=hodnota motor3,
// cislo4=hodnota motor4, hodnoty vsech motoru pro PWM 

void setup() {              //zadani parametru
  pinMode(potvrd, OUTPUT); //nastaveni PINU 3 na vystup
  pinMode(clk, OUTPUT);   //nastaveni PINU 4 na vystup 
  pinMode(data, OUTPUT);  //nastaveni PINU 2 na vystup
  pinMode(prvnimotor, OUTPUT); //vystup PWM motoru1
  pinMode(druhymotor,OUTPUT); //vystup PWM motoru2
  pinMode(tretimotor,OUTPUT); //vystup PWM motor3
  pinMode(ctvrtymotor,OUTPUT); //vystup PWM motor4
  pinMode(povolit,OUTPUT);     //vstup 13 OE 74HC595 povolí zapis pri LOW
  Serial.begin(9600);    //funkce pro komunikaci serioveho portu 
}

void loop(){                  //hlavni program
    if (Serial.available() > 0){ //testovani vstupu zda prisli data   
    cti=Serial.parseInt();  // nacteni hodnoty pro 74HC595 a ulozeni do promenne cti.
    cislo1=Serial.parseInt(); // nacteni hodnoty pro prvni motor PWM
    cislo2=Serial.parseInt(); // nacteni hodnoty pro druhy motor PWM
    cislo3=Serial.parseInt(); // nacteni hosnoty pro treti motor PWM
    cislo4=Serial.parseInt(); // nacteni hodnoty pro ctvrty motor PWM
    hodnota = cti; // ulozeni nactene hodnoty z promenne "cti" do promenne "hodnota"
    posli(hodnota); //zavolani funkce posli a predani ciselne hodnoty pro vystupy xxHC595
    delay(10);
    analogWrite(prvnimotor, cislo1); //hodnota pro otacky prvniho motoru 
    analogWrite(druhymotor, cislo2); //hodnota pro otacky druheho motoru 
    analogWrite(tretimotor, cislo3); //hodnota pro otacky tretiho motoru
    analogWrite(ctvrtymotor, cislo4); //hodnota pro otacky ctvrteho motoru
    Serial.print("74HC595 : "); //odeslani slova "hodnoty :" do terminalu v PC
    Serial.println(cti); //odeslani nactene hodnoty v promenne "cti" do terminalu v PC
    Serial.print("prvni motor : "); //cislo motoru
    Serial.println(cislo1); // hodnota pro PWM prvni motor
    Serial.print("druhy motor : "); //cislo motoru
    Serial.println(cislo2); // hodnota pro PWM druhy motor
    Serial.print("treti motor : "); //cislo motoru
    Serial.println(cislo3); // hodnota pro PWM treti motor
    Serial.print("ctvrty motor : "); //cislo motoru
    Serial.println(cislo4); // hodnota pro PWM ctvrty motor
    Serial.println(); //odradkovani na dalsi radek
    } 
  }
 
void posli(int hodnota){       //funkce pro vypocet a zadavani vystupnich hodnot
  digitalWrite(povolit,LOW); //vypnuti vystupu pro ovladani vstupu OE 74HC595
  delay(50); //casova prodleva po vypnuti vstupu OE
  digitalWrite(potvrd, LOW); //nastaveni potvrzeni dat na LOW umozni zapis dat
   delay(50);                 //casova prodleva
  for (int i=1;i<9;i++){     //posun 8 * bitu  
    if (hodnota % 2 > 0){    //porovnani dat 
      digitalWrite(data,HIGH); //zapnuti pinu 
    } else {                   
      digitalWrite(data,LOW); //vypnuti pinu
    }
    digitalWrite(clk,HIGH);  // zapnuti pinu pro vytvoreni pulzu
    delay(50);              //casova prodleva 
    digitalWrite(clk,LOW);  // vypnuti pinu pro vytvoreni pulzu
    hodnota = hodnota /  2; //vydeleni zadane hodnoty
  } 
    digitalWrite(potvrd,HIGH); //zapnuti pinu potvrzeni dat
    delay(50);                 //casova prodleva
   }

    
